/************************************************************************

   A+--------+(C)      Dada uma caixa retangular com lados paralelos aos
    |        |      eixos 'x' e 'y',  definida pelos pontos A e B;  e um
    |        |      segmento de  reta definido pelos pontos E e F,  esta
    |        |      funcao retorna 1 caso o segmento EF esteja dentro da
    |        |      caixa ou intersecciona alguma  de suas  arestas,  em
 (D)+--------+B     caso contrario retorna 0 (zero).

                    rymaeda@yahoo.com    16/04/2002

*************************************************************************/

int TesteSegmentoCaixa(int xa, int ya, int xb, int yb, int xe, int ye, int xf, int yf)
{
   int tmp1 = xf - xe, tmp2 = yf - ye, tmp3 = ya - yb,
       tmp4 = xa - xe, tmp5 = ya - ye, tmp6 = xb - xe;
   double u, t, Delta;

   if ((Delta = (double) tmp1 * tmp3) != 0)
   {
	  /* Teste do segmento AD */
	  u = (double) tmp3 *tmp4 / Delta;
	  t = (double) (tmp1 * tmp5 - tmp4 * tmp2) / Delta;
	  if ((t <= 1.0) && (t >= 0.0) && (u <= 1.0) && (u >= 0.0))
		 return 1;
	  /* Teste do segmento CB */
	  u = (double) tmp6 *tmp3 / Delta;
	  t = (double) (tmp1 * tmp5 - tmp6 * tmp2) / Delta;
	  if ((t <= 1.0) && (t >= 0.0) && (u <= 1.0) && (u >= 0.0))
		 return 1;
   }
   tmp3 = xa - xb;
   if ((Delta = tmp3 * tmp2) != 0)
   {
	  /* Teste do segmento AC */
	  u = (double) tmp3 *tmp5 / Delta;
	  t = (double) (tmp4 * tmp2 - tmp1 * tmp5) / Delta;
	  if ((t <= 1.0) && (t >= 0.0) && (u <= 1.0) && (u >= 0.0))
		 return 1;
	  /* Teste do segmento DB */
	  tmp6 = yb - ye;
	  u = (double) tmp3 *tmp6 / Delta;
	  t = (double) (tmp4 * tmp2 - tmp1 * tmp6) / Delta;
	  if ((t <= 1.0) && (t >= 0.0) && (u <= 1.0) && (u >= 0.0))
		 return 1;
   }
   /* Testa se o segmento esta dentro da caixa. */
   if ((xe > xa) && (xf > xa) && (xe < xb) && (xf < xb) ||	 /* para xa < xb */
	   (xe > xb) && (xf > xb) && (xe < xa) && (xf < xa))	    /* para xa > xb */
	  if ((ye > ya) && (yf > ya) && (ye < yb) && (yf < yb) || /* para ya < yb */
		  (ye > yb) && (yf > yb) && (ye < ya) && (yf < ya))    /* para ya > yb */
		 return 1;
   return 0;
}
