/**************************************************************

  Hit-Test: selecionando uma linha (segmento de reta) com o
  'mouse'. Teste/demo da funcao TestaSegmentoCaixa().
  Melhor se executado com resolucao de 800x600...

  Este programa foi gerado com a ajuda do 'Wizard' do
  LCC-Win32 Compiler System podendo ser compilado com
  outros compiladores Win32 (BCC32, MingW, CygWin...).

  Ricardo Y. Maeda (rymaeda@yahoo.com) 16/04/2002

**************************************************************/

#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <string.h>
#include <stdlib.h>
#include "boxtest.h"

#define IDM_STATUSBAR 3000

HINSTANCE hInst;		// Instance handle
HWND hwndMain;		//Main window handle

#define BOX_DIMX 6
#define BOX_DIMY 6

#define NMR_SEGMENTOS 20
typedef struct Segmento2D{
	int x1;
	int y1;
	int x2;
	int y2;
} SEGMENTO2D;

SEGMENTO2D Segmentos[NMR_SEGMENTOS];


LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam);

// Global Variables for the status bar control.

HWND  hWndStatusbar;

/*------------------------------------------------------------------------
 Procedure:     UpdateStatusBar ID:1
 Purpose:       Updates the statusbar control with the appropiate
                text
 Input:         lpszStatusString: Charactar string that will be shown
                partNumber: index of the status bar part number.
                displayFlags: Decoration flags
 Output:        none
 Errors:        none

------------------------------------------------------------------------*/
void UpdateStatusBar(LPSTR lpszStatusString, WORD partNumber, WORD displayFlags)
{
    SendMessage(hWndStatusbar,
                SB_SETTEXT,
                partNumber | displayFlags,
                (LPARAM)lpszStatusString);
}

/*------------------------------------------------------------------------
 Procedure:     InitializeStatusBar ID:1
 Purpose:       Initialize the status bar
 Input:         hwndParent: the parent window
                nrOfParts: The status bar can contain more than one
                part. What is difficult, is to figure out how this
                should be drawn. So, for the time being only one is
                being used...
 Output:        The status bar is created
 Errors:
------------------------------------------------------------------------*/
void InitializeStatusBar(HWND hwndParent,int nrOfParts)
{
    const int cSpaceInBetween = 8;
    int   ptArray[40];   // Array defining the number of parts/sections
    RECT  rect;
    HDC   hDC;

   /* * Fill in the ptArray...  */

    hDC = GetDC(hwndParent);
    GetClientRect(hwndParent, &rect);

    ptArray[nrOfParts-1] = rect.right;
    //---TODO--- Add code to calculate the size of each part of the status
    // bar here.

    ReleaseDC(hwndParent, hDC);
    SendMessage(hWndStatusbar,
                SB_SETPARTS,
                nrOfParts,
                (LPARAM)(LPINT)ptArray);

    UpdateStatusBar("Nenhuma linha selecionada", 0, 0);
    //---TODO--- Add code to update all fields of the status bar here.
    // As an example, look at the calls commented out below.

//    UpdateStatusBar("Cursor Pos:", 1, SBT_POPOUT);
//    UpdateStatusBar("Time:", 3, SBT_POPOUT);
}


/*------------------------------------------------------------------------
 Procedure:     CreateSBar ID:1
 Purpose:       Calls CreateStatusWindow to create the status bar
 Input:         hwndParent: the parent window
                initial text: the initial contents of the status bar
 Output:
 Errors:
------------------------------------------------------------------------*/
static BOOL CreateSBar(HWND hwndParent,char *initialText,int nrOfParts)
{
    hWndStatusbar = CreateStatusWindow(WS_CHILD | WS_VISIBLE | WS_BORDER|SBARS_SIZEGRIP,
                                       initialText,
                                       hwndParent,
                                       IDM_STATUSBAR);
    if(hWndStatusbar)
    {
        InitializeStatusBar(hwndParent,nrOfParts);
        return TRUE;
    }

    return FALSE;
}

/*<---------------------------------------------------------------------->*/
/*@@0->@@*/
static BOOL InitApplication(void)
{
	WNDCLASS wc;

	memset(&wc,0,sizeof(WNDCLASS));
	wc.style = CS_HREDRAW|CS_VREDRAW ;
	wc.lpfnWndProc = (WNDPROC)MainWndProc;
	wc.hInstance = hInst;
	wc.hbrBackground = (HBRUSH)(COLOR_WINDOW+1);
	wc.lpszClassName = "seleclinWndClass";
	wc.lpszMenuName = NULL;
	wc.hCursor = LoadCursor(hInst, "ID_BOXCUR");
	wc.hIcon = LoadIcon(NULL,IDI_APPLICATION);
	if (!RegisterClass(&wc))
		return 0;
/*@@0<-@@*/
	// ---TODO--- Call module specific initialization routines here

	return 1;
}

/*<---------------------------------------------------------------------->*/
/*@@1->@@*/
HWND CreateseleclinWndClassWnd(void)
{
	return CreateWindow("seleclinWndClass","seleclin",
		WS_MINIMIZEBOX|WS_VISIBLE|WS_CLIPSIBLINGS|WS_CLIPCHILDREN|WS_MAXIMIZEBOX|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_THICKFRAME,
		CW_USEDEFAULT,0,CW_USEDEFAULT,0,
		NULL,
		NULL,
		hInst,
		NULL);
}

/*<---------------------------------------------------------------------->*/
/*@@2->@@*/
LRESULT CALLBACK MainWndProc(HWND hwnd,UINT msg,WPARAM wParam,LPARAM lParam)
{
	int i;
	PAINTSTRUCT ps;
	HDC hdc;
	int aux;
	char String[100]="Nenhuma linha selecionada";
	TEXTMETRIC tm;

	switch (msg) {
/*@@3->@@*/
	case WM_PAINT:
		srand(1);
		hdc= BeginPaint(hwnd, &ps);
      SetTextAlign(hdc, TA_CENTER);
		for (i=NMR_SEGMENTOS-1; i>=0; i--){
			aux= ps.rcPaint.right;
			Segmentos[i].x1= (aux*rand())/RAND_MAX;
			Segmentos[i].x2= (aux*rand())/RAND_MAX;
			aux= ps.rcPaint.bottom;
			Segmentos[i].y1= (aux*rand())/RAND_MAX;
			Segmentos[i].y2= (aux*rand())/RAND_MAX;
			MoveToEx(hdc, Segmentos[i].x1, Segmentos[i].y1, NULL);
			LineTo(hdc, Segmentos[i].x2, Segmentos[i].y2);
			wsprintf(String, "%3d", i);
			TextOut(hdc, (Segmentos[i].x1+Segmentos[i].x2)/2, (Segmentos[i].y1+Segmentos[i].y2)/2, String, strlen(String));
		}
		EndPaint(hwnd, &ps);
		break;
	case WM_LBUTTONDOWN:
		aux= 1;
		hdc= GetDC(hwnd);
		for (i=NMR_SEGMENTOS-1; i>=0; i--){
			if(TesteSegmentoCaixa(LOWORD(lParam), HIWORD(lParam),
                               LOWORD(lParam)+BOX_DIMX, HIWORD(lParam)+BOX_DIMY,
			                      Segmentos[i].x1, Segmentos[i].y1,
			                      Segmentos[i].x2, Segmentos[i].y2)){
				wsprintf(String, "Selecianada a linha %3d", i);
				UpdateStatusBar(String, 0, 0);
				aux= 0;
				break;
			}
		}
		ReleaseDC(hwnd, hdc);
		if (aux)
			UpdateStatusBar("Nenhuma linha selecionada", 0, 0);
		break;
	case WM_SIZE:
		SendMessage(hWndStatusbar,msg,wParam,lParam);
		InitializeStatusBar(hWndStatusbar,1);
		break;
	case WM_CREATE:
		break;                        /* do Windows. */
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hwnd,msg,wParam,lParam);
	}
/*@@3<-@@*/
	return 0;
}
/*@@2<-@@*/

/*<---------------------------------------------------------------------->*/
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, INT nCmdShow)
{
	MSG msg;
	HANDLE hAccelTable;

	hInst = hInstance;
	if (!InitApplication())
		return 0;
	if ((hwndMain = CreateseleclinWndClassWnd()) == (HWND)0)
		return 0;
	CreateSBar(hwndMain,"Ready",1);
	ShowWindow(hwndMain,SW_SHOW);
	while (GetMessage(&msg,NULL,0,0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
